proc fromto {f t} {
	.s configure -from $f -to $t
}

set funcs {set_key set_fm_am set_gater set_delay}
set slider_funcs {{fromto [gv sa] [* 4 [gv sa]]} {fromto 0 480} {fromto 0 480} {fromto 0 100}}

trace add variable cur write go

proc go {name elem op} {
	uplevel {
		.l codnfigure -text [lindex $funcs $cur];
		eval [lindex $slider_funcs $cur]		
	}
}

proc set_key {v} {
	key $v
}

proc set_fm_am {v} {
	set_bpm fm $v
	set_bpm am $v
}

proc set_gater {v} {
	set_bpm g $v
}

proc set_delay {v} {
	sd all feedback [/ $v 100.0]
}

package require Tk
namespace path ::tcl::mathop

destroy .l .s
label .l
scale .s -command {[lindex $funcs $cur]}
grid .l .s -sticky nsew
grid rowconfigure . 0 -weight 1

proc curr x {
upvar cur xx
set xx $x
}

set cur 3
