package require Tk
namespace path ::tcl::mathop

set cur_sa [gv sa]
set from [* 0.5 $cur_sa]
set to [* 2 $cur_sa]


wm state . withdrawn

destroy .t

toplevel .t

entry .t.from -textvariable from 
bind .t.from <Return> {validate .t.from from}

entry .t.to -textvariable to
bind .t.to <Return> {validate .t.to to}

scale .t.s -orient horizontal -command key

pack .t.s -side top -fill x
pack .t.from -side left
pack .t.to -side right

wm title .t {set sa/key}

proc validate {textfield varname} {
	set text [$textfield get]
	set cmdargs [split $text]
	set cmdname [lindex $cmdargs 0]
	upvar $varname val
	if {[info commands $cmdname] eq $cmdname} {
		set val [eval $text]
	} else {
		set val $text
	}
	.t.s configure -$varname $val  
}

validate .t.from from
validate .t.to to
.t.s configure -variable cur_sa
