#ifndef __ui
#define __ui

#include <vector>
#include <string>
using namespace std;

struct ui {
	
	string name;	
  virtual void enter () {}
  virtual void leave () {}
  virtual bool handle_input() {return true;}
  virtual void draw() {}
  virtual void bg () {}
  virtual ~ui () {}
};

struct curve_editor;

struct uis_t : ui {
  
	ui* current;
	curve_editor* crved;
  std::vector<ui*> uis;
  
  static const int MAX_EDITORS = 8;
  static const int key [MAX_EDITORS];
  static ui* ed [MAX_EDITORS];

	uis_t ();
  void set_current (ui* u, int ised = 1);
  bool handle_input ();
	void draw ();
	bool set_editor (const string& name, int screen);
	
};


#endif
